Index: /LMDZ5/branches/testing/libf/phylmd/physiq.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2408)
@@ -3,7 +3,7 @@
 
 SUBROUTINE physiq (nlon,nlev, &
-     debut,lafin,jD_cur, jH_cur,pdtphys, &
+     debut,lafin,jD_cur_,jH_cur_,pdtphys_, &
      paprs,pplay,pphi,pphis,presnivs, &
-     u,v,t,qx, &
+     u,v,rot,t,qx, &
      flxmass_w, &
      d_u, d_v, d_t, d_qx, d_ps &
@@ -12,14 +12,16 @@
   USE ioipsl, only: histbeg, histvert, histdef, histend, histsync, &
        histwrite, ju2ymds, ymds2ju, getin
-  USE comgeomphy
+  USE geometry_mod, ONLY: cell_area, latitude_deg, longitude_deg
   USE phys_cal_mod, only: year_len, mth_len, days_elapsed, jh_1jan, year_cur, &
-       mth_cur, phys_cal_update
+       mth_cur,jD_cur, jH_cur, jD_ref, phys_cal_update
   USE write_field_phy
   USE dimphy
-  USE infotrac
-  USE mod_grid_phy_lmdz
+  USE infotrac_phy, ONLY: nqtot, nbtr, nqo, type_trac
+  USE mod_grid_phy_lmdz, ONLY: nbp_lon, nbp_lat, nbp_lev, klon_glo
   USE mod_phys_lmdz_para
   USE iophy
-  USE misc_mod, mydebug=>debug
+  USE print_control_mod, ONLY: mydebug=>debug , lunout, prt_level
+  USE phystokenc_mod, ONLY: offline, phystokenc
+  USE time_phylmdz_mod, only: raz_date, day_step_phy
   USE vampir
   USE pbl_surface_mod, ONLY : pbl_surface
@@ -46,5 +48,7 @@
   use radlwsw_m, only: radlwsw
   use phyaqua_mod, only: zenang_an
-  USE control_mod
+  USE time_phylmdz_mod, only: day_step_phy, annee_ref, day_ref, itau_phy, &
+                              start_time, pdtphys, day_ini
+  USE tracinca_mod, ONLY: config_inca
 #ifdef CPP_XIOS
   USE wxios, ONLY: missing_val, missing_val_omp
@@ -60,8 +64,11 @@
   USE YOERAD   , ONLY : NRADLP
 #endif
+  USE ioipsl_getin_p_mod, ONLY : getin_p
+
 
   !IM stations CFMIP
   USE CFMIP_point_locations
   use FLOTT_GWD_rando_m, only: FLOTT_GWD_rando
+  use ACAMA_GWD_rando_m, only: ACAMA_GWD_rando
 
   IMPLICIT none
@@ -109,15 +116,12 @@
   !! d_ps----output-R-tendance physique de la pression au sol
   !!======================================================================
-  include "dimensions.h"
   integer jjmp1
-  parameter (jjmp1=jjm+1-1/jjm)
-  integer iip1
-  parameter (iip1=iim+1)
+!  parameter (jjmp1=jjm+1-1/jjm) ! => (jjmp1=nbp_lat-1/(nbp_lat-1))
+!  integer iip1
+!  parameter (iip1=iim+1)
 
   include "regdim.h"
   include "dimsoil.h"
   include "clesphys.h"
-  include "temps.h"
-  include "iniprint.h"
   include "thermcell.h"
   !======================================================================
@@ -139,6 +143,7 @@
   !======================================================================
   ! Clef controlant l'activation du cycle diurne:
-  !cc      LOGICAL cycle_diurne
-  !cc      PARAMETER (cycle_diurne=.FALSE.)
+  ! en attente du codage des cles par Fred
+        INTEGER iflag_cycle_diurne
+        PARAMETER (iflag_cycle_diurne=1)
   !======================================================================
   ! Modele thermique du sol, a activer pour le cycle diurne:
@@ -215,7 +220,8 @@
   INTEGER nlon
   INTEGER nlev
-  REAL, intent(in):: jD_cur, jH_cur
-
-  REAL pdtphys
+  REAL, intent(in):: jD_cur_, jH_cur_ 
+! JD_cur and JH_cur to be used in physics are in phys_cal_mod
+  REAL,INTENT(IN) :: pdtphys_
+! NB: pdtphys to be used in physics is in time_phylmdz_mod
   LOGICAL debut, lafin
   REAL paprs(klon,klev+1)
@@ -229,4 +235,8 @@
   REAL u(klon,klev)
   REAL v(klon,klev)
+
+  REAL, intent(in):: rot(klon, klev)
+  ! relative vorticity, in s-1, needed for frontal waves
+
   REAL t(klon,klev),thetal(klon,klev)
   ! thetal: ligne suivante a decommenter si vous avez les fichiers     MPL 20130625
@@ -404,4 +414,8 @@
   REAL dt_a(klon,klev)
   REAL dq_a(klon,klev)
+  REAL d_t_adjwk(klon,klev)                !jyg
+  REAL d_q_adjwk(klon,klev)                !jyg
+  LOGICAL,SAVE :: ok_adjwk=.FALSE.
+  !$OMP THREADPRIVATE(ok_adjwk) 
   REAL, dimension(klon) :: www
   REAL, SAVE :: alp_offset
@@ -440,4 +454,7 @@
   integer :: tau_trig(klon)
 
+  REAL,SAVE :: random_notrig_max=1.
+  !$OMP THREADPRIVATE(random_notrig_max) 
+
   !--------Statistical Boundary Layer Closure: ALP_BL--------
   !---Profils de TKE dans et hors du thermique
@@ -494,5 +511,5 @@
   SAVE lmt_pas                ! frequence de mise a jour
   !$OMP THREADPRIVATE(lmt_pas) 
-  real zmasse(klon, llm),exner(klon, llm) 
+  real zmasse(klon, nbp_lev),exner(klon, nbp_lev) 
   !     (column-density of mass of air in a cell, in kg m-2)
   real, parameter:: dobson_u = 2.1415e-05 ! Dobson unit, in kg m-2
@@ -528,8 +545,4 @@
   EXTERNAL suphel    ! initialiser certaines constantes
   EXTERNAL transp    ! transport total de l'eau et de l'energie
-  EXTERNAL ecribina  ! ecrire le fichier binaire global
-  EXTERNAL ecribins  ! ecrire le fichier binaire global
-  EXTERNAL ecrirega  ! ecrire le fichier binaire regional
-  EXTERNAL ecriregs  ! ecrire le fichier binaire regional
   !IM
   EXTERNAL haut2bas  !variables de haut en bas
@@ -574,7 +587,9 @@
   !  REAL zxsnow(klon)
   REAL zxsnow_dummy(klon)
+  REAL zsav_tsol(klon)
   !
   REAL dist, rmu0(klon), fract(klon)
-  REAL zdtime, zlongi
+  REAL zrmu0(klon), zfract(klon)
+  REAL zdtime, zdtime1, zdtime2, zlongi
   !
   REAL qcheck
@@ -682,5 +697,5 @@
   REAL tabcntr0( length       )
   !
-  INTEGER ndex2d(iim*jjmp1)
+  INTEGER ndex2d(nbp_lon*nbp_lat)
   !IM
   !
@@ -691,15 +706,16 @@
   REAL zustrli(klon), zvstrli(klon)
   REAL zustrph(klon), zvstrph(klon)
-  REAL zustrhi(klon), zvstrhi(klon)
   REAL aam, torsfc
   !IM 141004 END
   !IM 190504 BEG
-  INTEGER ij, imp1jmp1
-  PARAMETER(imp1jmp1=(iim+1)*jjmp1)
+  INTEGER ij
+!  INTEGER imp1jmp1
+!  PARAMETER(imp1jmp1=(iim+1)*jjmp1)
   !ym A voir plus tard
-  REAL zx_tmp(imp1jmp1), airedyn(iim+1,jjmp1)
-  REAL padyn(iim+1,jjmp1,klev+1)
-  REAL dudyn(iim+1,jjmp1,klev)
-  REAL rlatdyn(iim+1,jjmp1)
+  REAL zx_tmp((nbp_lon+1)*nbp_lat)
+  REAL airedyn(nbp_lon+1,nbp_lat)
+  REAL padyn(nbp_lon+1,nbp_lat,klev+1)
+  REAL dudyn(nbp_lon+1,nbp_lat,klev)
+  REAL rlatdyn(nbp_lon+1,nbp_lat)
   !IM 190504 END
   LOGICAL ok_msk
@@ -713,6 +729,7 @@
   REAL zx_tmp_fi2d(klon)      ! variable temporaire grille physique
   REAL zx_tmp_fi3d(klon,klev) ! variable temporaire pour champs 3D 
-  REAL zx_tmp_2d(iim,jjmp1)
-  REAL zx_lon(iim,jjmp1), zx_lat(iim,jjmp1)
+  REAL zx_tmp_2d(nbp_lon,nbp_lat)
+  REAL zx_lon(nbp_lon,nbp_lat)
+  REAL zx_lat(nbp_lon,nbp_lat)
   !
   INTEGER nid_day_seri, nid_ctesGCM
@@ -889,7 +906,13 @@
 !albedo SB <<<
 
+  ! Ehouarn: set value of jjmp1 since it is no longer a "fixed parameter"
+  jjmp1=nbp_lat
+
   !======================================================================
   ! Gestion calendrier : mise a jour du module phys_cal_mod
   !
+  JD_cur=JD_cur_
+  JH_cur=JH_cur_
+  pdtphys=pdtphys_
   CALL phys_cal_update(jD_cur,jH_cur)
 
@@ -902,5 +925,5 @@
      igout=klon/2+1/klon
      write(lunout,*) 'DEBUT DE PHYSIQ !!!!!!!!!!!!!!!!!!!!'
-     write(lunout,*) 'igout, rlat, rlon ',igout, rlatd(igout)*180./3.141593, rlond(igout)*180./3.141593
+     write(lunout,*) 'igout, rlat, rlon ',igout, latitude_deg(igout), longitude_deg(igout)
      write(lunout,*) &
           'nlon,klev,nqtot,debut,lafin, jD_cur, jH_cur,pdtphys'
@@ -975,9 +998,11 @@
   pde_u(:,:) = 0.
   aam=0.
+  d_t_adjwk(:,:)=0
+  d_q_adjwk(:,:)=0
 
   alp_bl_conv(:)=0.
 
   torsfc=0.
-  forall (k=1: llm) zmasse(:, k) = (paprs(:, k)-paprs(:, k+1)) / rg
+  forall (k=1: nbp_lev) zmasse(:, k) = (paprs(:, k)-paprs(:, k+1)) / rg
 
 
@@ -993,4 +1018,6 @@
   IF (debut) THEN
      CALL suphel ! initialiser constantes et parametres phys.
+     CALL getin_p('random_notrig_max',random_notrig_max)
+     CALL getin_p('ok_adjwk',ok_adjwk)
   ENDIF
 
@@ -1033,4 +1060,8 @@
         piz_aero(:,:,:,:) = 0.
         cg_aero(:,:,:,:) = 0.
+
+        config_inca='none' ! default
+        CALL getin_p('config_inca',config_inca)
+
      END IF
 
@@ -1045,9 +1076,9 @@
      print*,'iflag_coupl,iflag_clos,iflag_wake', &
           iflag_coupl,iflag_clos,iflag_wake
-     print*,'CYCLE_DIURNE', cycle_diurne
+     print*,'iflag_CYCLE_DIURNE', iflag_cycle_diurne
      !
      IF (iflag_con.EQ.2.AND.iflag_cld_th.GT.-1) THEN
         abort_message = 'Tiedtke needs iflag_cld_th=-2 or -1'
-        CALL abort_gcm (modname,abort_message,1)
+        CALL abort_physic (modname,abort_message,1)
      ENDIF
      !
@@ -1073,5 +1104,12 @@
      ! pour obtenir le meme resultat.
      dtime=pdtphys
-     radpas = NINT( 86400./dtime/nbapp_rad)
+     IF (MOD(INT(86400./dtime),nbapp_rad).EQ.0) THEN
+       radpas = NINT( 86400./dtime/nbapp_rad)
+     ELSE 
+       WRITE(lunout,*) 'le nombre de pas de temps physique doit etre un multiple de nbapp_rad'
+       WRITE(lunout,*) 'changer nbapp_rad ou alors commenter ce test mais 1+1<>2'
+       abort_message='nbre de pas de temps physique n est pas multiple de nbapp_rad'
+       call abort_physic(modname,abort_message,1)
+     ENDIF
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 
@@ -1097,8 +1135,4 @@
      ENDIF
 
-     !IM cf. AM 081204 BEG
-     PRINT*,'cycle_diurne3 =',cycle_diurne
-     !IM cf. AM 081204 END
-     !
      CALL printflag( tabcntr0,radpas,ok_journe, &
           ok_instan, ok_region )
@@ -1108,5 +1142,5 @@
              pdtphys
         abort_message='Pas physique n est pas correct '
-        !           call abort_gcm(modname,abort_message,1)
+        !           call abort_physic(modname,abort_message,1)
         dtime=pdtphys
      ENDIF
@@ -1115,5 +1149,5 @@
              klon
         abort_message='nlon et klon ne sont pas coherents'
-        call abort_gcm(modname,abort_message,1)
+        call abort_physic(modname,abort_message,1)
      ENDIF
      IF (nlev .NE. klev) THEN
@@ -1121,12 +1155,12 @@
              klev
         abort_message='nlev et klev ne sont pas coherents'
-        call abort_gcm(modname,abort_message,1)
+        call abort_physic(modname,abort_message,1)
      ENDIF
      !
-     IF (dtime*REAL(radpas).GT.21600..AND.cycle_diurne) THEN 
+     IF (dtime*REAL(radpas).GT.21600..AND.iflag_cycle_diurne.GE.1) THEN 
         WRITE(lunout,*)'Nbre d appels au rayonnement insuffisant'
         WRITE(lunout,*)"Au minimum 4 appels par jour si cycle diurne"
         abort_message='Nbre d appels au rayonnement insuffisant'
-        call abort_gcm(modname,abort_message,1)
+        call abort_physic(modname,abort_message,1)
      ENDIF
      WRITE(lunout,*)"Clef pour la convection, iflag_con=", iflag_con
@@ -1183,5 +1217,5 @@
            IF(nCFMIP.GT.npCFMIP) THEN
               print*,'nCFMIP > npCFMIP : augmenter npCFMIP et recompiler'
-              call abort_gcm("physiq", "", 1)
+              call abort_physic("physiq", "", 1)
            else
               print*,'physiq npCFMIP=',npCFMIP,'nCFMIP=',nCFMIP
@@ -1331,5 +1365,5 @@
              rg, &
              ra, &
-             airephy, &
+             cell_area, &
              rlat, &
              rlon, &
@@ -1538,5 +1572,5 @@
   IF (ip_ebil_phy.ge.1) THEN 
      ztit='after dynamic'
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,1,1,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,1,1,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
@@ -1545,5 +1579,5 @@
      !     est egale a la variation de la physique au pas de temps precedent.
      !     Donc la somme de ces 2 variations devrait etre nulle.
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , zero_v, zero_v, zero_v, zero_v, zero_v &
           , zero_v, zero_v, zero_v, ztsol &
@@ -1688,5 +1722,5 @@
         IF (read_climoz/=-1) THEN
            abort_message ='read_climoz=-1 is recommended when solarlong0=1000.'
-           CALL abort_gcm (modname,abort_message,1)
+           CALL abort_physic (modname,abort_message,1)
         ENDIF
      ELSE
@@ -1749,8 +1783,8 @@
   IF (ip_ebil_phy.ge.2) THEN 
      ztit='after reevap'
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,2,1,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,1,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , zero_v, zero_v, zero_v, zero_v, zero_v &
           , zero_v, zero_v, zero_v, ztsol &
@@ -1796,29 +1830,55 @@
   ! non nul aux poles.
   IF (abs(solarlong0-1000.)<1.e-4) then
-     call zenang_an(cycle_diurne,jH_cur,rlat,rlon,rmu0,fract)
+     call zenang_an(iflag_cycle_diurne.GE.1,jH_cur,rlat,rlon,rmu0,fract)
+     JrNt = 1.0
   ELSE
-     !  Avec ou sans cycle diurne
-     IF (cycle_diurne) THEN
+  ! recode par Olivier Boucher en sept 2015
+     SELECT CASE (iflag_cycle_diurne)
+     CASE(0)  
+     !  Sans cycle diurne
+        CALL angle(zlongi, rlat, fract, rmu0)
+        swradcorr = 1.0
+        JrNt = 1.0
+        zrmu0 = rmu0
+     CASE(1)  
+     !  Avec cycle diurne sans application des poids
+     !  bit comparable a l ancienne formulation cycle_diurne=true
+     !  on integre entre gmtime et gmtime+radpas
         zdtime=dtime*REAL(radpas) ! pas de temps du rayonnement (s)
-        CALL zenang(zlongi,jH_cur,zdtime,rlat,rlon,rmu0,fract)
-     ELSE
-        CALL angle(zlongi, rlat, fract, rmu0)
-     ENDIF
+        CALL zenang(zlongi,jH_cur,0.0,zdtime,rlat,rlon,rmu0,fract)
+        zrmu0 = rmu0
+        swradcorr = 1.0
+     ! Calcul du flag jour-nuit
+        JrNt = 0.0
+        WHERE (fract.GT.0.0) JrNt = 1.0
+     CASE(2)  
+     !  Avec cycle diurne sans application des poids
+     !  On integre entre gmtime-pdtphys et gmtime+pdtphys*(radpas-1)
+     !  Comme cette routine est appele a tous les pas de temps de la physique
+     !  meme si le rayonnement n'est pas appele je remonte en arriere les
+     !  radpas-1 pas de temps suivant. Petite ruse avec MOD pour prendre en
+     !  compte le premier pas de temps de la physique pendant lequel itaprad=0 
+        zdtime1=dtime*REAL(-MOD(itaprad,radpas)-1)      
+        zdtime2=dtime*REAL(radpas-MOD(itaprad,radpas)-1) 
+        CALL zenang(zlongi,jH_cur,zdtime1,zdtime2,rlat,rlon,rmu0,fract)
+     !
+     ! Calcul des poids
+     !
+        zdtime1=-dtime !--on corrige le rayonnement pour representer le
+        zdtime2=0.0    !--pas de temps de la physique qui se termine
+        CALL zenang(zlongi,jH_cur,zdtime1,zdtime2,rlat,rlon,zrmu0,zfract)
+        swradcorr = 0.0
+        WHERE (rmu0.GE.1.e-10 .OR. fract.GE.1.e-10) swradcorr=zfract/fract*zrmu0/rmu0
+     ! Calcul du flag jour-nuit
+        JrNt = 0.0
+        WHERE (zfract.GT.0.0) JrNt = 1.0 
+     END SELECT 
   ENDIF
 
-  ! AI Janv 2014 
-  do i = 1, klon
-     if (fract(i).le.0.) then
-        JrNt(i)=0.
-     else
-        JrNt(i)=1.
-     endif
-  enddo
-
   if (mydebug) then
-     call writefield_phy('u_seri',u_seri,llm)
-     call writefield_phy('v_seri',v_seri,llm)
-     call writefield_phy('t_seri',t_seri,llm)
-     call writefield_phy('q_seri',q_seri,llm)
+     call writefield_phy('u_seri',u_seri,nbp_lev)
+     call writefield_phy('v_seri',v_seri,nbp_lev)
+     call writefield_phy('t_seri',t_seri,nbp_lev)
+     call writefield_phy('q_seri',q_seri,nbp_lev)
   endif
 
@@ -1887,5 +1947,5 @@
           dtime,     date0,     itap,    days_elapsed+1, &
           debut,     lafin, &
-          rlon,      rlat,      rugoro,  rmu0,      &
+          rlon,      rlat,      rugoro,  zrmu0,      &
           zsig,      sollwdown, pphi,    cldt,      &
           rain_fall, snow_fall, solsw,   sollw,     &
@@ -1963,8 +2023,8 @@
 
      if (mydebug) then
-        call writefield_phy('u_seri',u_seri,llm)
-        call writefield_phy('v_seri',v_seri,llm)
-        call writefield_phy('t_seri',t_seri,llm)
-        call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('u_seri',u_seri,nbp_lev)
+        call writefield_phy('v_seri',v_seri,nbp_lev)
+        call writefield_phy('t_seri',t_seri,nbp_lev)
+        call writefield_phy('q_seri',q_seri,nbp_lev)
      endif
 
@@ -2007,8 +2067,8 @@
      IF (ip_ebil_phy.ge.2) THEN 
         ztit='after surface_main'
-        CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime &
+        CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
              , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
              , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-        call diagphy(airephy,ztit,ip_ebil_phy &
+        call diagphy(cell_area,ztit,ip_ebil_phy &
              , zero_v, zero_v, zero_v, zero_v, sens &
              , evap  , zero_v, zero_v, ztsol &
@@ -2057,5 +2117,5 @@
   ENDDO
   IF (check) THEN
-     za = qcheck(klon,klev,paprs,q_seri,ql_seri,airephy)
+     za = qcheck(klon,klev,paprs,q_seri,ql_seri,cell_area)
      WRITE(lunout,*) "avantcon=", za
   ENDIF
@@ -2077,5 +2137,5 @@
   DO k = 1, klev
      DO i = 1, klon
-        omega(i,k) = RG*flxmass_w(i,k) / airephy(i)
+        omega(i,k) = RG*flxmass_w(i,k) / cell_area(i)
      END DO
   END DO
@@ -2085,5 +2145,5 @@
   IF (iflag_con.EQ.1) THEN
      abort_message ='reactiver le call conlmd dans physiq.F'
-     CALL abort_gcm (modname,abort_message,1)
+     CALL abort_physic (modname,abort_message,1)
      !     CALL conlmd (dtime, paprs, pplay, t_seri, q_seri, conv_q,
      !    .             d_t_con, d_q_con,
@@ -2133,4 +2193,29 @@
         enddo
      enddo
+!
+!jyg<
+     ! Perform dry adiabatic adjustment on wake profile
+     ! The corresponding tendencies are added to the convective tendencies
+     ! after the call to the convective scheme.
+     IF (iflag_wake>=1) then
+      IF (ok_adjwk) THEN
+        limbas(:) = 1
+        CALL ajsec(paprs, pplay, t_wake, q_wake, limbas, &
+                  d_t_adjwk, d_q_adjwk)
+      ENDIF
+!
+      DO k=1,klev
+        DO i=1,klon
+          IF (wake_s(i) .GT. 1.e-3) THEN
+            t_wake(i,k) = t_wake(i,k) + d_t_adjwk(i,k)
+            q_wake(i,k) = q_wake(i,k) + d_q_adjwk(i,k)
+            wake_deltat(i,k) = wake_deltat(i,k) + d_t_adjwk(i,k)
+            wake_deltaq(i,k) = wake_deltaq(i,k) + d_q_adjwk(i,k)
+          ENDIF
+        ENDDO
+      ENDDO
+     ENDIF ! (iflag_wake>=1)
+!>jyg
+!
 
      ! Calcul de l'energie disponible ALE (J/kg) et de la puissance
@@ -2223,5 +2308,5 @@
            else
        abort_message ='Ne pas passer la car www non calcule'
-       CALL abort_gcm (modname,abort_message,1)
+       CALL abort_physic (modname,abort_message,1)
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -2322,5 +2407,19 @@
            if (iflagctrl(i).le.1) itau_con(i)=itau_con(i)+1
         enddo
-
+!
+!jyg<
+!    Add the tendency due to the dry adjustment of the wake profile
+      IF (iflag_wake>=1) THEN
+        DO k=1,klev
+          DO i=1,klon
+            ftd(i,k) = ftd(i,k) + wake_s(i)*d_t_adjwk(i,k)/dtime
+            fqd(i,k) = fqd(i,k) + wake_s(i)*d_q_adjwk(i,k)/dtime
+            d_t_con(i,k) = d_t_con(i,k) + wake_s(i)*d_t_adjwk(i,k)
+            d_q_con(i,k) = d_q_con(i,k) + wake_s(i)*d_q_adjwk(i,k)
+          ENDDO
+        ENDDO
+      ENDIF
+!>jyg
+!
      ELSE ! ok_cvl
 
@@ -2403,5 +2502,5 @@
   ELSE
      WRITE(lunout,*) "iflag_con non-prevu", iflag_con
-     call abort_gcm("physiq", "", 1)
+     call abort_physic("physiq", "", 1)
   ENDIF
 
@@ -2415,8 +2514,8 @@
 
   if (mydebug) then
-     call writefield_phy('u_seri',u_seri,llm)
-     call writefield_phy('v_seri',v_seri,llm)
-     call writefield_phy('t_seri',t_seri,llm)
-     call writefield_phy('q_seri',q_seri,llm)
+     call writefield_phy('u_seri',u_seri,nbp_lev)
+     call writefield_phy('v_seri',v_seri,nbp_lev)
+     call writefield_phy('t_seri',t_seri,nbp_lev)
+     call writefield_phy('q_seri',q_seri,nbp_lev)
   endif
 
@@ -2424,8 +2523,8 @@
   IF (ip_ebil_phy.ge.2) THEN 
      ztit='after convect'
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , zero_v, zero_v, zero_v, zero_v, zero_v &
           , zero_v, rain_con, snow_con, ztsol &
@@ -2435,12 +2534,12 @@
   !
   IF (check) THEN
-     za = qcheck(klon,klev,paprs,q_seri,ql_seri,airephy)
+     za = qcheck(klon,klev,paprs,q_seri,ql_seri,cell_area)
      WRITE(lunout,*)"aprescon=", za
      zx_t = 0.0
      za = 0.0
      DO i = 1, klon
-        za = za + airephy(i)/REAL(klon)
+        za = za + cell_area(i)/REAL(klon)
         zx_t = zx_t + (rain_con(i)+ &
-             snow_con(i))*airephy(i)/REAL(klon)
+             snow_con(i))*cell_area(i)/REAL(klon)
      ENDDO
      zx_t = zx_t/za*dtime
@@ -2589,8 +2688,8 @@
   IF (ip_ebil_phy.ge.2) THEN 
      ztit='after wake'
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , zero_v, zero_v, zero_v, zero_v, zero_v &
           , zero_v, zero_v, zero_v, ztsol &
@@ -2682,5 +2781,5 @@
              ,ztv,zpspsk,ztla,zthl &
              !cc nrlmd le 10/04/2012
-             ,pbl_tke_input,pctsrf,omega,airephy &
+             ,pbl_tke_input,pctsrf,omega,cell_area &
              ,zlcl_th,fraca0,w0,w_conv,therm_tke_max0,env_tke_max0 &
              ,n2,s2,ale_bl_stat &
@@ -2734,4 +2833,5 @@
               proba_notrig(i)=1.
               random_notrig(i)=1e6*ale_bl_stat(i)-int(1e6*ale_bl_stat(i))
+              if ( random_notrig(i) > random_notrig_max ) random_notrig(i)=0.
               if ( ale_bl_trig(i) .lt. abs(cin(i))+1.e-10 ) then 
                  tau_trig(i)=tau_trig_shallow
@@ -2905,8 +3005,8 @@
   IF (ip_ebil_phy.ge.2) THEN 
      ztit='after dry_adjust'
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , zero_v, zero_v, zero_v, zero_v, zero_v &
           , zero_v, zero_v, zero_v, ztsol &
@@ -2958,12 +3058,12 @@
   ENDDO
   IF (check) THEN
-     za = qcheck(klon,klev,paprs,q_seri,ql_seri,airephy)
+     za = qcheck(klon,klev,paprs,q_seri,ql_seri,cell_area)
      WRITE(lunout,*)"apresilp=", za
      zx_t = 0.0
      za = 0.0
      DO i = 1, klon
-        za = za + airephy(i)/REAL(klon)
+        za = za + cell_area(i)/REAL(klon)
         zx_t = zx_t + (rain_lsc(i) &
-             + snow_lsc(i))*airephy(i)/REAL(klon)
+             + snow_lsc(i))*cell_area(i)/REAL(klon)
      ENDDO
      zx_t = zx_t/za*dtime
@@ -2973,8 +3073,8 @@
   IF (ip_ebil_phy.ge.2) THEN 
      ztit='after fisrt'
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , zero_v, zero_v, zero_v, zero_v, zero_v &
           , zero_v, rain_lsc, snow_lsc, ztsol &
@@ -2984,8 +3084,8 @@
 
   if (mydebug) then
-     call writefield_phy('u_seri',u_seri,llm)
-     call writefield_phy('v_seri',v_seri,llm)
-     call writefield_phy('t_seri',t_seri,llm)
-     call writefield_phy('q_seri',q_seri,llm)
+     call writefield_phy('u_seri',u_seri,nbp_lev)
+     call writefield_phy('v_seri',v_seri,nbp_lev)
+     call writefield_phy('t_seri',t_seri,nbp_lev)
+     call writefield_phy('q_seri',q_seri,nbp_lev)
   endif
 
@@ -3056,5 +3156,5 @@
      !jq - Johannes Quaas, 27/11/2003 (quaas@lmd.jussieu.fr)
      IF (flag_aerosol .gt. 0) THEN
-        IF (iflag_rrtm .EQ. 0) THEN !--old radiation
+         IF (iflag_rrtm .EQ. 0) THEN !--old radiation
            IF (.NOT. aerosol_couple) THEN
               !
@@ -3069,8 +3169,11 @@
            IF (aerosol_couple .AND. config_inca == 'aero' ) THEN
             abort_message='config_inca=aero et rrtm=1 impossible'
-            call abort_gcm(modname,abort_message,1)
+            call abort_physic(modname,abort_message,1)
            ELSE
 !
 #ifdef CPP_RRTM
+           IF (NSW.EQ.6) THEN
+!--new aerosol properties
+!
              CALL readaerosol_optic_rrtm( debut, aerosol_couple, &
              new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
@@ -3080,9 +3183,32 @@
              tausum_aero, tau3d_aero)
 
-             CALL aeropt_lw_rrtm
+           ELSE IF (NSW.EQ.2) THEN 
+!--for now we use the old aerosol properties
+!
+              CALL readaerosol_optic( &
+                   debut, new_aod, flag_aerosol, itap, jD_cur-jD_ref, &
+                   pdtphys, pplay, paprs, t_seri, rhcl, presnivs,  &
+                   mass_solu_aero, mass_solu_aero_pi,  &
+                   tau_aero, piz_aero, cg_aero,  &
+                   tausum_aero, tau3d_aero)
+!
+                   !--natural aerosols
+                   tau_aero_sw_rrtm(:,:,1,:)=tau_aero(:,:,3,:)
+                   piz_aero_sw_rrtm(:,:,1,:)=piz_aero(:,:,3,:)
+                   cg_aero_sw_rrtm (:,:,1,:)=cg_aero (:,:,3,:)
+                   !--all aerosols
+                   tau_aero_sw_rrtm(:,:,2,:)=tau_aero(:,:,2,:)
+                   piz_aero_sw_rrtm(:,:,2,:)=piz_aero(:,:,2,:)
+                   cg_aero_sw_rrtm (:,:,2,:)=cg_aero (:,:,2,:)
+           ELSE
+              abort_message='Only NSW=2 or 6 are possible with aerosols and iflag_rrtm=1'
+              call abort_physic(modname,abort_message,1)
+           ENDIF
+
+           CALL aeropt_lw_rrtm
+!
 #else
-
-              abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
-              call abort_gcm(modname,abort_message,1)
+           abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
+           call abort_physic(modname,abort_message,1)
 #endif
               !
@@ -3117,5 +3243,5 @@
 
            abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
-           call abort_gcm(modname,abort_message,1)
+           call abort_physic(modname,abort_message,1)
 #endif
         ENDIF
@@ -3217,8 +3343,8 @@
   IF (ip_ebil_phy.ge.2) THEN 
      ztit="after diagcld"
-     CALL diagetpq(airephy,ztit,ip_ebil_phy,2,2,dtime &
+     CALL diagetpq(cell_area,ztit,ip_ebil_phy,2,2,dtime &
           , t_seri,q_seri,ql_seri,qs_seri,u_seri,v_seri,paprs,pplay &
           , d_h_vcol, d_qt, d_qw, d_ql, d_qs, d_ec)
-     call diagphy(airephy,ztit,ip_ebil_phy &
+     call diagphy(cell_area,ztit,ip_ebil_phy &
           , zero_v, zero_v, zero_v, zero_v, zero_v &
           , zero_v, zero_v, zero_v, ztsol &
@@ -3286,5 +3412,5 @@
         CALL AEROSOL_METEO_CALC( &
              calday,pdtphys,pplay,paprs,t,pmflxr,pmflxs, &
-             prfl,psfl,pctsrf,airephy,rlat,rlon,u10m,v10m)
+             prfl,psfl,pctsrf,cell_area,rlat,rlon,u10m,v10m)
      END IF
 
@@ -3297,5 +3423,5 @@
           rlat, &
           rlon, &
-          airephy, &
+          cell_area, &
           paprs, &
           pplay, &
@@ -3316,6 +3442,6 @@
           ibas_con, &
           cldfra, &
-          iim, &
-          jjm, &
+          nbp_lon, &
+          nbp_lat-1, &
           tr_seri, &
           ftsol, &
@@ -3346,10 +3472,10 @@
         IF (ok_cdnc.AND.NRADLP.NE.3) THEN
            abort_message='RRTM choix incoherent NRADLP doit etre egal a 3 pour ok_cdnc' 
-           call abort_gcm(modname,abort_message,1)
+           call abort_physic(modname,abort_message,1)
         endif
 #else
 
         abort_message='You should compile with -rrtm if running with iflag_rrtm=1'
-        call abort_gcm(modname,abort_message,1)
+        call abort_physic(modname,abort_message,1)
 #endif
      ENDIF
@@ -3376,4 +3502,5 @@
   cldtaupirad = cldtaupi
   cldemirad   = cldemi
+  cldfrarad   = cldfra
 
   !
@@ -3444,9 +3571,18 @@
 
      if (mydebug) then
-        call writefield_phy('u_seri',u_seri,llm)
-        call writefield_phy('v_seri',v_seri,llm)
-        call writefield_phy('t_seri',t_seri,llm)
-        call writefield_phy('q_seri',q_seri,llm)
+        call writefield_phy('u_seri',u_seri,nbp_lev)
+        call writefield_phy('v_seri',v_seri,nbp_lev)
+        call writefield_phy('t_seri',t_seri,nbp_lev)
+        call writefield_phy('q_seri',q_seri,nbp_lev)
      endif
+
+!
+!sonia :   If Iflag_radia >=2, pertubation of some variables input to radiation
+!(DICE)
+!
+      IF (iflag_radia .ge. 2) THEN
+        zsav_tsol (:) = zxtsol(:)
+        call perturb_radlwsw(zxtsol,iflag_radia)
+      ENDIF
 
      IF (aerosol_couple) THEN 
@@ -3457,5 +3593,5 @@
              wo(:, :, 1), &
              cldfrarad, cldemirad, cldtaurad, &
-             heat,heat0,cool,cool0,radsol,albpla, &
+             heat,heat0,cool,cool0,albpla, &
              topsw,toplw,solsw,sollw, &
              sollwdown, &
@@ -3503,5 +3639,5 @@
              zqsat, flwc, fiwc, &
              ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
-             heat,heat0,cool,cool0,radsol,albpla, &
+             heat,heat0,cool,cool0,albpla, &
              topsw,toplw,solsw,sollw, &
              sollwdown, &
@@ -3559,5 +3695,5 @@
                    zqsat, flwc, fiwc, &
                    ref_liq, ref_ice, ref_liq_pi, ref_ice_pi, &
-                   heatp,heat0p,coolp,cool0p,radsolp,albplap, &
+                   heatp,heat0p,coolp,cool0p,albplap, &
                    topswp,toplwp,solswp,sollwp, &
                    sollwdownp, &
@@ -3583,4 +3719,10 @@
      ENDIF ! aerosol_couple
      itaprad = 0
+!
+!  If Iflag_radia >=2, reset pertubed variables
+!
+      IF (iflag_radia .ge. 2) THEN
+        zxtsol(:) = zsav_tsol (:)
+      ENDIF
   ENDIF ! MOD(itaprad,radpas)
   itaprad = itaprad + 1
@@ -3600,6 +3742,4 @@
      swup=0.    ! MPL 27102011 pour les fichiers AMMA_profiles et AMMA_scalars
      swup0=0.
-     swdn=0.
-     swdn0=0.
      lwup=0.
      lwup0=0.
@@ -3609,10 +3749,25 @@
 
   !
+  ! Calculer radsol a l'exterieur de radlwsw
+  ! pour prendre en compte le cycle diurne
+  ! recode par Olivier Boucher en sept 2015
+  !
+  radsol=solsw*swradcorr+sollw
+  if (ok_4xCO2atm) then
+    radsolp=solswp*swradcorr+sollwp
+  endif
+
+  !
   ! Ajouter la tendance des rayonnements (tous les pas)
-  !
-  d_t_swr(:,:)=heat(:,:)*dtime/RDAY
-  d_t_lwr(:,:)=-cool(:,:)*dtime/RDAY
-  d_t_sw0(:,:)=heat0(:,:)*dtime/RDAY
-  d_t_lw0(:,:)=-cool0(:,:)*dtime/RDAY
+  ! avec une correction pour le cycle diurne dans le SW
+  !
+  
+  DO k=1, klev
+    d_t_swr(:,k)=swradcorr(:)*heat(:,k)*dtime/RDAY
+    d_t_sw0(:,k)=swradcorr(:)*heat0(:,k)*dtime/RDAY
+    d_t_lwr(:,k)=-cool(:,k)*dtime/RDAY
+    d_t_lw0(:,k)=-cool0(:,k)*dtime/RDAY
+  ENDDO
+
   CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW',abortphy)
   CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW',abortphy)
@@ -3620,8 +3775,8 @@
   !
   if (mydebug) then
-     call writefield_phy('u_seri',u_seri,llm)
-     call writefield_phy('v_seri',v_seri,llm)
-     call writefield_phy('t_seri',t_seri,llm)
-     call writefield_phy('q_seri',q_seri,llm)
+     call writefield_phy('u_seri',u_seri,nbp_lev)
+     call writefield_phy('v_seri',v_seri,nbp_lev)
+     call writefield_phy('t_seri',t_seri,nbp_lev)
+     call writefield_phy('q_seri',q_seri,nbp_lev)
   endif
 
